/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AmazonAdsDataExtractorConnectorFormAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AmazonAdsDataExtractorConnectorFormAllOf{}

// AmazonAdsDataExtractorConnectorFormAllOf struct for AmazonAdsDataExtractorConnectorFormAllOf
type AmazonAdsDataExtractorConnectorFormAllOf struct {
	// Label of the source
	Label *string `json:"label,omitempty"`
	// Dataddo Flow endpoint
	Flow *string `json:"flow,omitempty"`
	// Dataddo token
	Token *string `json:"token,omitempty"`
}

// NewAmazonAdsDataExtractorConnectorFormAllOf instantiates a new AmazonAdsDataExtractorConnectorFormAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAmazonAdsDataExtractorConnectorFormAllOf() *AmazonAdsDataExtractorConnectorFormAllOf {
	this := AmazonAdsDataExtractorConnectorFormAllOf{}
	return &this
}

// NewAmazonAdsDataExtractorConnectorFormAllOfWithDefaults instantiates a new AmazonAdsDataExtractorConnectorFormAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAmazonAdsDataExtractorConnectorFormAllOfWithDefaults() *AmazonAdsDataExtractorConnectorFormAllOf {
	this := AmazonAdsDataExtractorConnectorFormAllOf{}
	return &this
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *AmazonAdsDataExtractorConnectorFormAllOf) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AmazonAdsDataExtractorConnectorFormAllOf) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *AmazonAdsDataExtractorConnectorFormAllOf) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *AmazonAdsDataExtractorConnectorFormAllOf) SetLabel(v string) {
	o.Label = &v
}

// GetFlow returns the Flow field value if set, zero value otherwise.
func (o *AmazonAdsDataExtractorConnectorFormAllOf) GetFlow() string {
	if o == nil || IsNil(o.Flow) {
		var ret string
		return ret
	}
	return *o.Flow
}

// GetFlowOk returns a tuple with the Flow field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AmazonAdsDataExtractorConnectorFormAllOf) GetFlowOk() (*string, bool) {
	if o == nil || IsNil(o.Flow) {
		return nil, false
	}
	return o.Flow, true
}

// HasFlow returns a boolean if a field has been set.
func (o *AmazonAdsDataExtractorConnectorFormAllOf) HasFlow() bool {
	if o != nil && !IsNil(o.Flow) {
		return true
	}

	return false
}

// SetFlow gets a reference to the given string and assigns it to the Flow field.
func (o *AmazonAdsDataExtractorConnectorFormAllOf) SetFlow(v string) {
	o.Flow = &v
}

// GetToken returns the Token field value if set, zero value otherwise.
func (o *AmazonAdsDataExtractorConnectorFormAllOf) GetToken() string {
	if o == nil || IsNil(o.Token) {
		var ret string
		return ret
	}
	return *o.Token
}

// GetTokenOk returns a tuple with the Token field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AmazonAdsDataExtractorConnectorFormAllOf) GetTokenOk() (*string, bool) {
	if o == nil || IsNil(o.Token) {
		return nil, false
	}
	return o.Token, true
}

// HasToken returns a boolean if a field has been set.
func (o *AmazonAdsDataExtractorConnectorFormAllOf) HasToken() bool {
	if o != nil && !IsNil(o.Token) {
		return true
	}

	return false
}

// SetToken gets a reference to the given string and assigns it to the Token field.
func (o *AmazonAdsDataExtractorConnectorFormAllOf) SetToken(v string) {
	o.Token = &v
}

func (o AmazonAdsDataExtractorConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AmazonAdsDataExtractorConnectorFormAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.Flow) {
		toSerialize["flow"] = o.Flow
	}
	if !IsNil(o.Token) {
		toSerialize["token"] = o.Token
	}
	return toSerialize, nil
}

type NullableAmazonAdsDataExtractorConnectorFormAllOf struct {
	value *AmazonAdsDataExtractorConnectorFormAllOf
	isSet bool
}

func (v NullableAmazonAdsDataExtractorConnectorFormAllOf) Get() *AmazonAdsDataExtractorConnectorFormAllOf {
	return v.value
}

func (v *NullableAmazonAdsDataExtractorConnectorFormAllOf) Set(val *AmazonAdsDataExtractorConnectorFormAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableAmazonAdsDataExtractorConnectorFormAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableAmazonAdsDataExtractorConnectorFormAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAmazonAdsDataExtractorConnectorFormAllOf(val *AmazonAdsDataExtractorConnectorFormAllOf) *NullableAmazonAdsDataExtractorConnectorFormAllOf {
	return &NullableAmazonAdsDataExtractorConnectorFormAllOf{value: val, isSet: true}
}

func (v NullableAmazonAdsDataExtractorConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAmazonAdsDataExtractorConnectorFormAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
